## Script (Python) "popupref_setup"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=prepare reference picker data
from Products.CMFPlone import Batch
SEPARATOR = '&type:list'
BATCH_SIZE = 100
DEBUG = 0                   #Debug switch to see structure in reference_picker
request = context.REQUEST
response = request.RESPONSE
safe_eval = context.safeeval
query_string = ''
data = {}

data['debug'] = DEBUG

form_handler = request.form.get('handler', None)
handler = request.get('handler', form_handler)
data['handler'] = handler

b_start = request.get('b_start', 0)
batch_size = request.get('batch_size', BATCH_SIZE)
query_string = 'handler=%s&batch_size:int=%s' % (handler, batch_size)

initial_location = request.get('init_location', '')
location = context.restrictedTraverse(initial_location)
data['location'] = location

query_first = request.get('query_first', None)
if query_first:
    data['query_first'] = query_first = safe_eval(query_first)

safe_critiera = request.get('base_search', None)
base_search = safe_eval(safe_critiera)
data['base_search'] = base_search

form_allowed_types = request.form.get('allowed_types', None)
allowed_types = request.get('type', form_allowed_types)

query_types = None
if request.has_key('select_type'):
    select_type = request['select_type']
    if select_type[0]:
        query_types = select_type
    else:
        query_types = allowed_types 
data['query_allowed_types']=query_types

if query_types:
    separated_args = SEPARATOR + SEPARATOR.join(allowed_types)
    query_string += separated_args
data['query_string']=query_string 

#inline queryresults.py
#all of this could be moved into functions to made more sane

form_query = {'Type':allowed_types,
              'SearchableText':request.get('SearchableText','')}

query = base_search or {}
for elt in form_query.items():   # add form search elements to base
    query[elt[0]] = elt[1]

query_results = []
query_type = 'catalog'

if request.has_key('submit') or base_search and query_first:
   query_results = [brain.getObject() for brain in context.queryCatalog(query)]

if not query_results:
    query_results = location.contentValues()
    query_type = 'listing'

batched_results = Batch(query_results, batch_size, int(b_start), orphan=1)

if DEBUG:
    data['query_type']=query_type
    data['query']=query
    data['debugdata'] = data.copy()

data.update( {'query':query,
              'type':query_type,
              'results':query_results,
              'batched_results':batched_results} )

return data

